#ifndef _CANLIGHT_CAN_H__
#define _CANLIGHT_CAN_H__

#include "can_mindsensors.h"

#define CAN_MSGID_DTYPE_LIGHT  0x08000000

#define MS_API_COLOR  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT)

#define MS_API_COLOR_SET     (MS_API_COLOR | (0 << CAN_MSGID_API_S))
#define MS_API_COLOR_SHOW    (MS_API_COLOR | (1 << CAN_MSGID_API_S))
#define MS_API_COLOR_BLINK   (MS_API_COLOR | (2 << CAN_MSGID_API_S))
#define MS_API_COLOR_FADE    (MS_API_COLOR | (3 << CAN_MSGID_API_S))
#define MS_API_COLOR_FLASH   (MS_API_COLOR | (4 << CAN_MSGID_API_S))
#define MS_API_COLOR_SWEEP   (MS_API_COLOR | (5 << CAN_MSGID_API_S))
#define MS_API_COLOR_LOAD    (MS_API_COLOR | (6 << CAN_MSGID_API_S))
#define MS_API_COLOR_RESET   (MS_API_COLOR | (7 << CAN_MSGID_API_S))

#define MSR_STATUS_DATA  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | DATA_COLOR)

#define MSR_FIRMWARE_VERSION  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | FIRMWARE)
#define MSR_DEVNAME           (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | DEVNAME)
#define MSR_DEVSERNO          (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | DEVSERNO)

#define MSR_BLINK      (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | BLINK)
#define MSR_BOOTLOADE  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | BOOTLOADE)
#define MSR_CHANGE_ID  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_LIGHT | CHANGE_ID)

#define MSR_VBATT  0
#define MSR_COLOR  2

#define DATA_COLOR  0x00002400

// The Reserved device type identifiers in the Message Id.
#define CAN_MSGID_DTYPE_CANLIGHT_UPDATE 0x1B000000

// The mindsensors Firmware Update API definitions.
#define MS_API_CANLIGHT_UPD           (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_CANLIGHT_UPDATE)
#define MS_API_CANLIGHT_UPD_REQUEST   (MS_API_CANLIGHT_UPD | 0x180) // (MS_API_CANLIGHT_UPD | (0 << CAN_MSGID_API_S))
#define MS_API_CANLIGHT_UPD_DOWNLOAD  (MS_API_CANLIGHT_UPD | (1 << CAN_MSGID_API_S))
#define MS_API_CANLIGHT_UPD_RESET     (MS_API_CANLIGHT_UPD | (3 << CAN_MSGID_API_S))
#define MS_API_CANLIGHT_UPD_ACK       (MS_API_CANLIGHT_UPD | 0x100) // (MS_API_CANLIGHT_UPD | (4 << CAN_MSGID_API_S))

#endif
