#ifndef _SD540_CAN_H__
#define _SD540_CAN_H__

#include "can_mindsensors.h"

// The Reserved device type identifiers in the Message Id.
#define CAN_MSGID_DTYPE_MOTOR  0x02000000

// Limit switch bits
#define SD540_LIMIT_FWD_STATE 0
#define SD540_LIMIT_REV_STATE 1
#define SD540_CFG_LIMIT_MODE  2
#define SD540_CFG_LIMIT_FWD   3
#define SD540_CFG_LIMIT_REV   4
#define SD540_BRAKE_COAST     5
#define SD540_REV_FWD         6
#define SD540_FAULT           7

#define DATA_STATE    0x00002400
#define DATA_PWM      0x00002800
#define DATA_ENCODER  0x00002C00

#define MSR_STATUS1_DATA      (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | DATA_STATE)
#define MSR_STATUS2_DATA      (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | DATA_PWM)
#define MSR_STATUS3_DATA      (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | DATA_ENCODER)
#define MSR_FIRMWARE_VERSION  (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | FIRMWARE)
#define MSR_DEVNAME           (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | DEVNAME)
#define MSR_DEVSERNO          (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | DEVSERNO)
#define MSR_BLINK             (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | BLINK)
#define MSR_BOOTLOADER        (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | BOOTLOADER)
#define MSR_CHANGE_ID         (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | CHANGE_ID)

#define CAN_API_MC_CFG          0x00001c00
#define MS_API_CFG              (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | CAN_API_MC_CFG)
#define MS_API_CFG_REV_FWD      (MS_API_CFG | (0 << CAN_MSGID_API_S))
#define MS_API_CFG_POT_TURNS    (MS_API_CFG | (2 << CAN_MSGID_API_S))
#define MS_API_CFG_BRAKE_COAST  (MS_API_CFG | (3 << CAN_MSGID_API_S))
#define MS_API_CFG_LIMIT_MODE   (MS_API_CFG | (4 << CAN_MSGID_API_S))
#define MS_API_CFG_LIMIT_FWD    (MS_API_CFG | (5 << CAN_MSGID_API_S))
#define MS_API_CFG_LIMIT_REV    (MS_API_CFG | (6 << CAN_MSGID_API_S))
#define MS_API_CFG_MAX_VOUT     (MS_API_CFG | (7 << CAN_MSGID_API_S))
#define MS_API_CFG_FAULT_TIME   (MS_API_CFG | (8 << CAN_MSGID_API_S))

#define CAN_API_MC_VOLTAGE    0x00000000
#define MS_API_VOLT           (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_MOTOR | CAN_API_MC_VOLTAGE)
//#define CAN_MSGID_API_S     6 // definition moved to can_mindsensors.h
#define MS_API_VOLT_T_SET     (MS_API_VOLT | (5 << CAN_MSGID_API_S))
#define MS_API_VOLT_SET_RAMP  (MS_API_VOLT | (3 << CAN_MSGID_API_S))

// The Reserved device type identifiers in the Message Id.
#define CAN_MSGID_DTYPE_SD540C_UPDATE 0x1A000000

// The mindsensors Firmware Update API definitions.
#define MS_API_SD540C_UPD           (CAN_MSGID_MFR_MS | CAN_MSGID_DTYPE_SD540C_UPDATE)
#define MS_API_SD540C_UPD_REQUEST   (MS_API_SD540C_UPD | 0x180) // (MS_API_SD540C_UPD | (0 << CAN_MSGID_API_S))
#define MS_API_SD540C_UPD_DOWNLOAD  (MS_API_SD540C_UPD | (1 << CAN_MSGID_API_S))
#define MS_API_SD540C_UPD_RESET     (MS_API_SD540C_UPD | (3 << CAN_MSGID_API_S))
#define MS_API_SD540C_UPD_ACK       (MS_API_SD540C_UPD | 0x100) // (MS_API_SD540C_UPD | (4 << CAN_MSGID_API_S))

#endif
